<?php
/**
* Newswire sync to 5 sites
* Webhook to reciev plugin request to sync article to 5 sites
*/
add_action('wp_loaded', 'http_newswire_sync_handler');
function http_newswire_sync_handler() {

    $action  = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : null;

    $article = isset( $_REQUEST['article'] ) ? $_REQUEST['article'] : null;

    $tags = isset( $_REQUEST['tags'] ) ? $_REQUEST['tags'] : null;

    $meta = isset( $_REQUEST['meta'] ) ? $_REQUEST['meta'] : null;
    
    $author = isset( $_REQUEST['author'] ) ? $_REQUEST['author'] : null;
    
    $api_key  = isset( $_REQUEST['api_key'] ) ? $_REQUEST['api_key'] : null;

    $email = isset( $_REQUEST['email'] ) ? $_REQUEST['email'] : null;

    $category = isset( $_REQUEST['category'] ) ? $_REQUEST['category'] : null;

    //force to pr
    $article['post_type'] = 'pr';

    if ( 'newswire_freesites_sync' == $action ) 
    {
        //remote post to newswire to validate api
        if ( is_http_valid_newswire_api($api_key, $email) ) {

            $options = newswire_options();
            $article['post_status'] =  $options['rss_importstatus'];
    
            $id = wp_insert_post( $article );
            
            update_post_meta($id, 'newswire_data', $meta);
            update_post_meta($id, 'newswire_postback_url', $_POST['postback_url']);

            die($id);
        
        } else {
          //  error_log('Invalid API');
           // error_log($api_key);
        }
        
    } else {
        
        return;
    }
    exit;
}

/**
*
*/
function is_http_valid_newswire_api($api_key, $email) {
   
    require_once NEWSWIRE_DIR . 'classes/newsroom-http-client.php';
    //update_post_meta($post_id, 'freesites_cron_sync', time());
    //step1 - check if you have a valid api

    //validate_newswire_api();
    $client = Newswire_Client::getInstance();

    $client->setEmail( $email );

    $client->setApiKey( $api_key );

    $client->setSecretKey('');

    $response = $client->test();

   
    $status = wp_remote_retrieve_response_code($response);


    if ($status == 200) {
        return true;
    }

    return false;
}

/**
*
*/
function newswire_remote_clone_pr($article, $meta, $author) {

    global $wpdb;
    /*
     * new post data array
     */
    $args = array(
        'post_content' => $article['post_content'],
        'post_excerpt' => $article['post_excerpt'],
        'post_status' => 'publish',
        'post_title' => $article['post_title'],
        'post_type' => 'pr',
    );

   
    $new_post_id = wp_insert_post($args);

    //set terms

    //set meta

}