<?php
/**
* @package: newswirexpress
*
*/

if ( !function_exists('newswire_admin_menu')):
/**
 * Add submenu pages to custom post type press_release
 *
 */
add_action('admin_menu', 'newswire_admin_menu', 1);
function newswire_admin_menu() {
    /**
     * global wp vars
     */

    global $submenu;
    global $menu;
    global $_wp_real_parent_file;
    global $_wp_submenu_nopriv;
    global $_registered_pages;
    global $_parent_pages;

    global $typenow, $pagenow, $submenu_file, $post, $parent_file;
    //echo $submenu_file;
    $options = newswire_options();

    //- make sure to get a correct index so not to override others
    if (current_user_can('edit_pressroom_blocks') || current_user_can('prreporter_cap_only') || current_user_can('manage_options')) {
        $menu['5.000123456'] = array('PressRoom', 'edit_pressroom_blocks', 'edit.php?post_type=pressroom', '', 'menu-top menu-icon-pressroom', 'menu-pressroom', 'div');
    }

    //NewswireXpress Menu
    if (current_user_can('manage_options')) {
        $menu['75.001123456'] = array('NewswireXpress', 'manage_options', 'edit.php?post_type=pr', '', 'menu-top menu-icon-pressroom', 'menu-pressroom-ninja', 'div');
    }

    //add menu page
    //add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position )

    // All News menu
    $i = 0;
    if (current_user_can('PRReporter')) {

        $GLOBALS['wp_post_types']['pr']->labels->name = 'My Press Releases';
    } elseif (current_user_can('manage_options')) {
        $submenu['edit.php?post_type=pr'][++$i] = array(
            $page_title = __('All News', 'newswire')
            , $capability = 'administrator'
            , ('edit.php?post_type=pr'),
        );
    }

    // add settings Menu
    add_submenu_page('edit.php?post_type=pr', $page_title = __('Settings', 'newswire'), $menu_title = __('Settings', 'newswire'), $capability = 'administrator', 'newsroom-settings', $function = 'newswire_settings_page_callback');

/** PressRoom Block menus */
    $i = 0;

    if (current_user_can('prreporter_cap_only') || current_user_can('author')) {
        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('My Press Releases', 'newswire'))
            , $capability = 'edit_pressroom_block', ('edit.php?post_type=pr'),
        );

    } else {
        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('All PressRoom Blocks', 'newswire'))
            , $capability = 'edit_pressroom_block', ('edit.php?post_type=pressroom'),
        );
    }

    if (current_user_can('edit_pressroom_blocks') || current_user_can('prreporter_cap_only') ) {

        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Press Release', 'newswire'))
            , $capability = 'edit_pressroom_block', ('post-new.php?post_type=pr'),
        );
    }

    if ( current_user_can('author') || current_user_can('edit_others_pressroom_blocks')):
        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Text Block', 'newswire'))
            , $capability = 'edit_others_pressroom_blocks', ('post-new.php?post_type=pin_as_text'),
        );

        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Embed Block', 'newswire'))
            , $capability = 'edit_others_pressroom_blocks', ('post-new.php?post_type=pin_as_embed'),
        );

        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Image Album', 'newswire'))
            , $capability = 'edit_others_pressroom_blocks', ('post-new.php?post_type=pin_as_image'),
        );

        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Quote Block', 'newswire'))
            , $capability = 'edit_others_pressroom_blocks', ('post-new.php?post_type=pin_as_quote'),
        );

        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Social Media', 'newswire'))
            , $capability = 'edit_others_pressroom_blocks', ('post-new.php?post_type=pin_as_social'),
        );

        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Link Block', 'newswire'))
            , $capability = 'edit_others_pressroom_blocks', ('post-new.php?post_type=pin_as_link'),
        );

        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Contact Block', 'newswire'))
            , $capability = 'edit_others_pressroom_blocks', ('post-new.php?post_type=pin_as_contact'),
        );

        if ( isset($options['latest_press_releases']) && $options['latest_press_releases'] && get_post($options['latest_press_releases']) ) {
             $submenu['edit.php?post_type=pressroom'][++$i] = array(
                $menu_title = sprintf('<span class="">%s</span>', __('Add Latest PR Block', 'newswire'))
            , $capability = 'edit_pressroom_blocks', ('post.php?post='.$options['latest_press_releases'].'&action=edit'),
            );
        } else {
             $submenu['edit.php?post_type=pressroom'][++$i] = array(
                $menu_title = sprintf('<span class="">%s</span>', __('Add Latest PR Block', 'newswire'))
            , $capability = 'edit_pressroom_blocks', ('post-new.php?post_type=pin_as_latestpr'),
            );
        }
        
        $submenu['edit.php?post_type=pressroom'][++$i] = array(
            $menu_title = sprintf('<span class="">%s</span>', __('Add Linked Image Block', 'newswire'))
            , $capability = 'edit_pressroom_blocks', ('post-new.php?post_type=pin_as_imglink'),
        ); 
        
    endif;
}

endif;
