<?php
/*
add_action('plugins_loaded', 'newswire_setup_newswire_config');
function newswire_setup_newswire_config(){
    global $newswire_config;

    $newswire_config = wp_parse_args(newswire_options(), newswire_config('setting'));

}*/

if ( !function_exists('newswire_page_layout_options')):
/**
 *
 * Page Layout Options blog or default (pin type listing)
 *
 * @param $args array
 * @return void
 */
function newswire_page_layout_options($args) {

    echo '<div id="toggle-' . $args['field'] . '">';

    $options = newswire_options();

    if ($options[$args['field']] == 'blog') {

        if ($args['field'] == 'newsroom_layout') {
            echo ' <label><input type="radio" name="newswire_options[' . $args['field'] . ']" value="blog" checked="checked" > Blog </label>';
        }

        echo ' <label><input type="radio" name="newswire_options[' . $args['field'] . ']" value="default" data-toggle="toggle" data-target=".toggle-settings-pressroom_styles"> Default </label>';
    } else {
        if ($args['field'] == 'newsroom_layout') {
            echo ' <label><input type="radio" name="newswire_options[' . $args['field'] . ']" value="blog"> Blog </label>';
        }

        echo ' <label><input type="radio" name="newswire_options[' . $args['field'] . ']" value="default" checked="checked" > Default </label>';
    }

    echo '</div>';
}
endif;


if ( !function_exists('newswire_settings_tab_header')):
function newswire_settings_tab_header() {
    ?><li class="newswire-tab "><a href="#newswire-settings-general"><?php  _e('API', 'newswire');?></a></li>
        <li class="newswire-tab "><a href="#newswire-settings-newsroom"><?php _e('NewsRoom', 'newswire');?></a></li>
        <li class="newswire-tab "><a href="#newsroom-settings-general"><?php  _e('NewsRoom Settings', 'newswire');?></a></li>
       
        <?php /*<li class="newswire-tab hide-if-no-js"><a href="#newswire-settings-categories"><?php _e( 'Categories', 'newswire' ); ?></a></li> */?>
        <?php /*<li class="newswire-tab hide-if-no-js"><a href="#newswire-settings-shortcodes"><?php _e( 'Shortcodes', 'newswire' ); ?></a></li> */?>
        <li class="newswire-tab "><a href="#pressroom-settings-general"><?php _e('PressRoom Settings', 'newswire');?></a></li>
        <li class="newswire-tab "><a href="#newswire-settings-rss"><?php      _e('NewsRoom RSS', 'newswire');?></a></li>

        <li class="newswire-tab "><a href="#pressroom-settings-rss"><?php     _e('Press Release RSS', 'newswire');?></a></li>
        <li class="newswire-tab "><a href="#pressroom-settings-css"><?php     _e('CSS', 'newswire');?></a></li>
    <?php
}
endif;



/**
 * Settings pages for newsroom and pressroom
 */
add_action('admin_init', 'newswire_tab_settings_content');
function newswire_tab_settings_content() {

    # Register our setting so that $_POST handling is done for us and
    # our callback function just has to echo the <input>
    # callback validator is being called for each input
    register_setting('newswire_options', 'newswire_options', 'newswire_options_validator');

    //validate_newswire_api();
    //add_settings_field( $id, $title, $callback, $page, $section, $args );
    
    $page = 'newsroom-settings';


//FIRST TAB
    // Add the section to reading settings so we can add our
    // fields to it
    $section = 'newswire-settings-general';
    $args = null;
    add_settings_section($section, '', 'newswire_option_api_section_handler', $page);
        //  add_settings_field( $id, $title, $callback, $page, $section, $args );
        add_settings_field($id = 'newswire_api_email', $title = 'Newswire API Email', $callback = 'newswire_option_email', $page, $section, $args);
        add_settings_field($id = 'newswire_api_key', $title = 'Newswire API KEY', $callback = 'newswire_option_api_key_callback', $page, $section, $args);
        //add_settings_field($id = 'newswire_api_secret', $title = 'Newswire API secret key', $callback = 'newswire_option_api_secret', $page, $section, $args);
        add_settings_field($id = 'newswire_api_validate', $title = '', $callback = 'newswire_option_api_validate_callback', $page, $section, $args);
        
        // Post status of the imported press release
        add_settings_field($id = 'newswire-pressroom-rss-importstatus'
            , $title = __('Post Status', 'newswire')
            , $callback = 'newswire_settings_input'
            , $page
            , $section
            , $args = array('field' => 'rss_importstatus', 'options' => array('publish' => 'Published', 'draft' => 'Draft', 'pending' => 'Pending'), 'type' => 'select', 'description' => '')
        );


    
///////////////////////////
//SECOND TAB - Newsroom
///////////////////////////
    $section = 'newswire-settings-newsroom';
    add_settings_section($section, '', 'newswire_localnewsroom_option_handler', $page); 
        add_settings_field('newsroom_show_categories', 'Article per page', 'newswire_newsroom_pinperpage', $page, $section, $args = null);
        add_settings_field('newswire-newsroom-categoryfilter', 'Create Section and Category Pages', 'newswire_newsroom_categoryfilter', $page, $section, $args = null);

///////////////////////////
//THIRD TAB 
///////////////////////////

    $section = 'newsroom-settings-general';
    add_settings_section($section, '', 'newswire_newsroom_settings_section', $page);
        //add_settings_field ( 'newswire-newsroom-layout', 'Layout Options', 'newswire_page_layout_options', $page , $section, $args = null );
        add_settings_field($id = 'newswire-newsroom-layout'
            , $title = __('Layout Option', 'newswire')
            , $callback = 'newswire_page_layout_options'
            , $page
            , $section
            , $args = array('class' => 'toggle-settings', 'field' => 'newsroom_layout')
        );

        add_settings_field($id = 'newswire-newsroom-pin-content-settings'
            , $title = __('Pin', 'newswire')
            , $callback = 'newswire_pressroom_pin'
            , $page
            , $section
            , $args = array('class' => 'toggle-settings', 'field' => 'newsroom_styles', 'placeholder' => __('or Enter URL for background image i.e http://myco.com/bg.png', 'newswire'))
        );

        //add reset button
        add_settings_field($id = 'newswire-newsroom-reset-button'
            , $title = '' // __('Upload Background', 'newswire')
            , $callback = 'newswire_pressroom_resetbutton'
            , $page
            , $section
            , $args = array('class' => 'toggle-settings', 'field' => 'newsroom_styles', 'placeholder' => __('or Enter URL for background image i.e http://myco.com/bg.png', 'newswire'))
        );


////////////////////////////////////////
// FOURTH TAB-  PRESSROOM SETTINGS
///////////////////////////////////////

    # pressroom settings page
    $section = 'pressroom-settings-general';
    
    add_settings_section($section, '', 'newswire_settings_section', $page);
    
        add_settings_field($id = 'newswire-pressroom-pin-content-settings'
            , $title = __('Pin', 'newswire')
            , $callback = 'newswire_pressroom_pin'
            , $page
            , $section
            , $args = array('class' => 'toggle-settings', 'field' => 'pressroom_styles', 'placeholder' => __('or Enter URL for background image i.e http://myco.com/bg.png', 'newswire'))
        );

        add_settings_field($id = 'newswire-pressroom-pin-header-settings'
            , $title = __('Pin Header', 'newswire')
            , $callback = 'newswire_pressroom_pinheader'
            , $page
            , $section
            , $args = array('class' => 'toggle-settings', 'field' => 'pressroom_styles', 'placeholder' => __('or Enter URL for background image i.e http://myco.com/bg.png', 'newswire'))
        );

        //add pinfooter settings
        add_settings_field($id = 'newswire-pressroom-pin-footer-settings'
            , $title = __('Pin Footer', 'newswire')
            , $callback = 'newswire_pressroom_pinfooter'
            , $page
            , $section
            , $args = array('class' => 'toggle-settings', 'field' => 'pressroom_styles', 'placeholder' => __('or Enter URL for background image i.e http://myco.com/bg.png', 'newswire'))
        );

        //add reset button
        add_settings_field($id = 'newswire-pressroom-reset-button'
            , $title = '' // __('Upload Background', 'newswire')
            , $callback = 'newswire_pressroom_resetbutton'
            , $page
            , $section
            , $args = array('class' => 'toggle-settings', 'field' => 'pressroom_styles', 'placeholder' => __('or Enter URL for background image i.e http://myco.com/bg.png', 'newswire'))
        );

/////////////////////////////////
// FIFTH TAB - NEWSROOM RSS 
/////////////////////////////////
    $section = 'newswire-settings-rss';
    add_settings_section($section, '', 'newswire_settings_pressroom_rss_section', $page);

        add_settings_field($id = 'newswire-pressroom-rss'
            , $title = __('URLs', 'newswire')
            , $callback = 'newswire_settings_input'
            , $page
            , $section
            , $args = array('field' => 'newsroom_rss',
                'placeholder' => __('Enter RSS Feed for Press Releases i.e. ', 'newswire'),
                'description' => 'e.g http://newswire.net/rssfeeds/channel/feed/rss/article/user/500/category/1. One rss per line',
                'type' => 'textarea',
                'attr' => array('rows' => 5, 'cols' => 100),
            )
        );

        add_settings_field($id = 'newswire-newsroom-rss-maxpost'
            , $title = __('Maximum Count', 'newswire')
            , $callback = 'newswire_settings_text'
            , $page
            , $section
            , $args = array('field' => 'newsroom_rss_maxpost', 'attr' => array('size' => '2'), 'description' => 'Maximum number of articles that can be imported per frequency setting')
        );

        // item link
        add_settings_field($id = 'newswire-pressroom-rss-item-link'
            , $title = __('Link Item to', 'newswire')
            , $callback = 'newswire_settings_input'
            , $page
            , $section
            , $args = array('field' => 'newsroom_rss_linkto', 'options' => array('remote' => 'Feed Source', 'wp' => 'Wordpress'), 'type' => 'select', 'description' => 'Press release link')
        );
    
        //frequency to fetch feed for new press release
        add_settings_field($id = 'newswire-pressroom-rss-frequency'
            , $title = __('Frequency', 'newswire')
            , $callback = 'newswire_settings_input'
            , $page
            , $section
            , $args = array('field' => 'newsroom_rss_frequency', 'options' => array('newswire_cron_hourly' => 'Once Hourly', 'newswire_cron_twice_daily' => 'Twice Daily', 'newswire_cron_once_daily' => 'Once Daily'), 'type' => 'select', 'description' => 'How often will the rss import run')
        );

/////////////////////////////////////////
//SIXTH TAB - PRESS RELEASE RSS
/////////////////////////////////////////   
    //pressroom rss tab
    $section = 'pressroom-settings-rss';
    add_settings_section($section, '', 'newswire_settings_pressroom_rss_section', $page);

    //Enable/Disable rss support for press release
    //disabled by default
    /*
    add_settings_field( $id = 'newswire-pressroom-rss-enable'
    , $title = __('Enable', 'newswire')
    , $callback = 'newswire_settings_input'
    , $page
    , $section
    , $args =array( 'field' => 'pressroom_rss_enable', 'options' => array('0'=>'No', '1'=> 'Yes') , 'type'=> 'select')
    );
     */
    // url
        add_settings_field($id = 'newswire-pressroom-rss'
            , $title = __('URLs', 'newswire')
            , $callback = 'newswire_settings_input'
            , $page
            , $section
            , $args = array('field' => 'pressroom_rss',
                'placeholder' => __('Enter RSS Feed for Press Releases i.e. ', 'newswire'),
                'description' => 'e.g http://newswire.net/rssfeeds/channel/feed/rss/article/user/500/category/1. One rss per line',
                'type' => 'textarea',
                'attr' => array('rows' => 5, 'cols' => 100),
            )
        );

        add_settings_field($id = 'newswire-pressroom-rss-maxpost'
            , $title = __('Maximum Count', 'newswire')
            , $callback = 'newswire_settings_text'
            , $page
            , $section
            , $args = array('field' => 'pressroom_rss_maxpost', 'attr' => array('size' => '2'), 'description' => 'Maximum number of articles that can be imported per frequency setting')
        );

        // item link

        add_settings_field($id = 'newswire-pressroom-rss-item-link'
            , $title = __('Link Item to', 'newswire')
            , $callback = 'newswire_settings_input'
            , $page
            , $section
            , $args = array('field' => 'pressroom_rss_linkto', 'options' => array('remote' => 'Feed Source', 'wp' => 'Wordpress'), 'type' => 'select', 'description' => 'Press release link')
        );
        //frequency to fetch feed for new press release
        add_settings_field($id = 'newswire-pressroom-rss-frequency'
            , $title = __('Frequency', 'newswire')
            , $callback = 'newswire_settings_input'
            , $page
            , $section
            , $args = array('field' => 'pressroom_rss_frequency', 'options' => array('newswire_cron_hourly' => 'Once Hourly', 'newswire_cron_twice_daily' => 'Twice Daily', 'newswire_cron_once_daily' => 'Once Daily'), 'type' => 'select', 'description' => 'How often will the rss import run')
        );
    
// SEVENTH TAB - CUSTOM CSS
    //css section
    $section = 'pressroom-settings-css';
    add_settings_section($section, '', 'newswire_settings_pressroom_css_section', $page);
        add_settings_field('pressroom-settings-css', '', 'newswire_settings_input', $page, $section, $args = array('type' => 'textarea', 'field' => 'pressroom_custom_css'));

}//end admin_init hook
