<?php

if ( !function_exists('newswire_maybe_create_page_after_upgrade')):
add_action('admin_init', 'newswire_maybe_create_page_after_upgrade');
function newswire_maybe_create_page_after_upgrade(){
    $options = newswire_options();

    if (!isset($options['newsroom_page_template'])) {
        $page_id = wp_insert_post(array(
            'post_title' => 'newsroom',
            'post_type' => 'page',
            'post_status' => 'publish',
            'ping_status' => 'closed',
            'comment_status' => 'closed',
            'post_content' => '[Xpress]',
        ));
        $options['newsroom_page_template'] = $page_id;
        
        update_post_meta($page_id, 'admin_notices', '<p>Do not remove the shortcode [Xpress] from this page.  The contents that display on this page can be modified visiting NewswireXpress >> Settings in the dashboard.  <br>' . sprintf('<a href="%s">%s</a>', admin_url('edit.php?post_type=pr&page=newsroom-settings'), admin_url('edit.php?post_type=pr&page=newsroom-settings')) . ' <br/><a href="#" class="hide-notice" type="newsroom">Hide this notice</a></p>');
        
        update_newswire_options($options);
    }

}
endif;

if ( !function_exists('newswire_maybe_autocreate_pages') ) :
    /**
    * auto create category pages if user modify category selection from plugin setting
    */
add_action('newswire_categories_change', 'newswire_maybe_autocreate_pages', 10, 1 );
function newswire_maybe_autocreate_pages( $options = null) {
    

    $categories = newswire_fetch_categories(0);

    if ( empty($categories)  || empty($options) ) return;

    $template = array(
        'post_status' => 'publish',
        'post_type' => 'page',
        'ping_status' => 'closed',
        'comment_status' => 'closed',
        'post_author' => 1,
    );

    //Parent page, childdren of newsroom
    foreach ($categories as $category_id => $page) {
        //skip
        if (strtolower($page['name']) != 'news') //dont skip news
        {
            if (!in_array($category_id, $options['include_categories'])) {
                continue;
            }
        }

//var_dump($page);
        $exists = get_page_by_title($page['name']);

        $my_page = array(
            'post_name' => $page['name'],
            'post_content' => '[Xpress type="newsroom" category="' . $category_id . '"]',
            'post_title' => $page['name'],
            'post_parent' => $options['newsroom_page_template'],
        );
        $my_page = array_merge($my_page, $template);

        //Top page no parent
        $id = ($exists ? $exists->ID : wp_insert_post($my_page));
        update_post_meta($id, 'newswire_category', $category_id);

        if (isset($page['sub']) && is_array($page['sub'])) {
            foreach ($page['sub'] as $sub_id => $value) {

                //skip
                if (strtolower($value['name']) != 'news') //dont skip news
                {
                    if (!in_array($category_id . '_' . $sub_id, $options['include_categories'])) {
                        continue;
                    }
                }

                //check
                $child = get_page_by_title($value['name']);

                $child_page = array(
                    'post_name' => $value['name'],
                    'post_title' => $value['name'],
                    'post_content' => '[Xpress type="newsroom" category="' . $sub_id . '"]',
                    'post_parent' => $id,
                );
                $child_page = array_merge($child_page, $template);

                $subparentid = ($child->ID ? $child->ID : wp_insert_post($child_page));
                update_post_meta($id, 'newswire_category', $subparentid);

                //if( !isset( $child_id ) )
                //  $subparentid = ()wp_insert_post( $child_page );

                //loop another
                /*if( isset( $value['subsub'] ) &&  is_array( $value['subsub'] ) )
            {

            //inner loop
            foreach( $value['subsub'] as $subsub_id => $childest )
            {

            //skip
            if ( strtolower($childest['name']) != 'news') //dont skip news
            if ( !in_array($subsub_id, $options['include_categories'] ) ) continue;

            //check
            $childest_id = get_page_by_title( $childest['name'] );

            $child_page = array(
            'post_name'   => $childest['name'],
            'post_title'  => $childest['name'],
            'post_content' => '[prninja type="newsroom" category="'.$subsub_id.'"]',
            'post_parent' => $subparentid
            );
            $child_page = array_merge( $child_page, $template );

            if( !isset( $childest ) ) wp_insert_post( $child_page );

            }
            }//end inner
             */

            }
        } else {

        }
    }

    // exit;
}

endif;
