<?php

if ( !function_exists('newswire_pr_metabox_seo_tab_content')):
/**
* @package: newswirexpress
*/
add_action('newswire_pr_metabox_seo_tab', 'newswire_pr_metabox_seo_tab_content', 10 , 1);
function newswire_pr_metabox_seo_tab_content($post_meta){
    global $newswire_config;
    ?>
    <div id="nwire-seo-tools" class="newswire-tab-panel"  style="display: none;">
        <p class="howto"><?php //echo $newswire_config['tooltip']['seo_tools_tab']?></p>
        <?php
            echo newswire_generate_meta_box_fields(newswire_post_meta_box_elements('seo_tools'), $post_meta);
        ?>
        </div>
    <?php
}
endif;


add_action('newswire_pr_metabox_iframe_tab', 'newswire_pr_metabox_iframe_tab_content', 10, 1);
function newswire_pr_metabox_iframe_tab_content($post_meta) {
    ?><!-- add iframe //-->
        <div id="newswire-iframe-builder">
            <p class="howto">
            Embed Media Box.  Embedded media is most often a movie from Youtube.com, etc.  However, any HTML code can be inserted into this media box.  The information in this box will be displayed according to the “Style” selected.  This box is 300 pixels wide, and a maximum of 1200 high (lesser dimensions are allowable).  Always carefully preview your additions to the Embed Media Box prior to submission.  How this box appears in preview will be exactly how it appears to the readers of your article.</p>
            <?php

                 echo newswire_generate_meta_box_fields(newswire_post_meta_box_elements('iframe_builder'), $post_meta);

            ?>
        </div>
    <?php
}

if ( !function_exists('newswire_pr_metabox_tabs_header') ):
    add_action('newswire_pr_metabox_tabs_header', 'newswire_pr_metabox_tabs_header');
    function newswire_pr_metabox_tabs_header(){
        ?>  <li class="newswire-tab "><a href="#nwire-author-info"><?php _e('Author Info');?></a></li>
            <li class="newswire-tab hide-if-no-js"><a href="#nwire-company-info"><?php _e('Company Info');?></a></li>
            <li class="newswire-tab hide-if-no-js"><a href="#nwire-seo-tools"><?php _e('SEO Tools');?></a></li>
            <li class="newswire-tab hide-if-no-js"><a href="#newswire-add-image"><?php _e('Add Image');?></a></li>
            <li class="newswire-tab hide-if-no-js"><a href="#newswire-iframe-builder"><?php _e('iFrame Builder');?></a></li>
        <?php
    }
endif;


if ( !function_exists('newswire_stored_company_profile_metabox')):
function newswire_stored_company_profile_metabox() {
    global $newswire_config;
    if (current_user_can('administrator')) {
        return array(

            'name' => __('Use Info Stored in Company Profile?', 'newswire'),
            'desc' => __($newswire_config['tooltip']['company_info_profile'], 'newswire'),
            'id' => 'company_id',
            'toggle_id' => 'company_profile',
            'type' => 'callback',
            'callback' => 'newswire_toogle_company_id',
        );
    }
    return null;
}
endif;

if ( !function_exists('newswire_post_meta_box_elements')) :
/**
* Generate metabox for pr post type
*/
function newswire_post_meta_box_elements($panel) {

    global $newswire_config;

    $tabs = array(
        /*
        'article_status' => array(
        array ( "name" => __('Article Status','newswire' ),
        "desc"  => __('Indicates pending, published, not submitted', 'newswire'),
        "id"    => "article_status",
        'type'  => 'text',
        'width' => '20%',
        'type'  => 'callback',
        'callback' =>  'newswire_article_status'
        )
        ),
         */
        'category' => array(
            array("name" => __('Category', 'newswire'),
                "desc" => __('Choose a category that is most reflective of the voice of your article, news, press release, interview, review, or editorial.  Click on the preceding links to learn more about each of these styles of writing.', 'newswire'),
                "id" => "category_id",
                "type" => "callback",
                'callback' => 'newswire_meta_category_dropdown',
            ),

        ),

        'bonus_category' => array(
            array("name" => __('Bonus Category', 'newswire'),
                "desc" => __('Choose a category that is most reflective of the voice of your article, news, press release, interview, review, or editorial.  Click on the preceding links to learn more about each of these styles of writing.', 'newswire'),
                "id" => "category_id2",
                "type" => "callback",
                'callback' => 'newswire_select_categories',
            ),
        ),

        'author_info' => array(
            /* convert to callback */
            /* array ( "name" => __('User ID','newswire'),
            "desc" => '',
            "id" => "user_id",
            'attrib' => array('readonly'=> "true" ),
            "type" => "text",
            ),*/

            array(
                'name' => __('Contact Email', 'newswire'),
                'desc' => __($newswire_config['tooltip']['contact_email'], 'newswire'),
                'id' => 'contact_email',
                'type' => 'text',

            ),

            array(
                'name' => __('Pen Name', 'newswire'),
                'desc' => __($newswire_config['tooltip']['pen_name'], 'newswire'),
                'id' => 'pen_name',
                'type' => 'text',

            ),

            /* convert this to callback */
            array(
                'name' => __('Link Name?', 'newswire'),
                'desc' => __($newswire_config['tooltip']['link_name'], 'newswire'),
                'id' => 'profile_url',
                'toggle_id' => 'link_name',
                'type' => 'callback',
                'callback' => 'newswire_toggle_link_name',
            ),
        ),

        'company_info' => array(

            //Include Company Info in Article Body?
            array(

                'name' => __('Include Company Info in Article Body?', 'newswire'),
                'desc' => __($newswire_config['tooltip']['company_info_include'], 'newswire'),
                'value' => 1,
                'id' => 'show_company_info',
                'type' => 'callback',
                'callback' => 'newswire_toggle_include_company_body',

            ),

            //Use Info Stored in Company Profile?
            newswire_stored_company_profile_metabox(),

            //Schema
            array(

                'name' => __('Schema', 'newswire'),
                'desc' => __($newswire_config['tooltip']['company_info_schema'], 'newswire'),
                'id' => 'schema_id',
                'type' => 'callback',
                'callback' => 'newswire_select_schema',
            ),

            //Contact Funnel
            /*
            array (

            'name' => __('Contact Funnel','newswire'),
            'desc' => __( $newswire_config['tooltip']['company_info_contact_funnel'] ,'newswire'),
            'id' => 'author_info_contact_email_field',
            'type' => 'html',
            'html' => '<select name="page_id" id="page_id">
            <option value="2" label="Newswire Network Ltd">Newswire Network Ltd</option>
            </select>'

            ),*/

            array(

                'name' => __('Company Name', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_name',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',

            ),

            array(

                'name' => __('Ticker Symbols', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_tickers',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',

            ),

            array(

                'name' => __('Address', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_address',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',
            ),

            array(

                'name' => __('City', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_city',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',
            ),

            array(

                'name' => __('Country', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_country',
                'type' => 'callback',
                'callback' => 'newswire_select_countries',
                'toggle_class' => 'toggle_company_info',

            ),

            array(

                'name' => __('State or Province', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_state',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',

            ),

            array(

                'name' => __('Postal Code', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_zip',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',
            ),

            array(

                'name' => __('Telephone', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_telephone',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',
            ),

            array(
                'name' => __('Email', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_email',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',
            ),
            array(
                'name' => __('Website', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_website',
                'type' => 'text',
                'toggle_class' => 'toggle_company_info',
            ),

            array(

                'name' => __('Company Description', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_desc',
                'prefix_id' =>'nwexpress_',
                'type' => 'textarea',   
                'toggle_class' => 'toggle_company_info',

            ),


        ),

        'pressroom_contact_pin' => array(
            array(

                'name' => __('Add Image to Contact Block', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'contact_image',
                'type' => 'callback',
                'callback' => 'newswire_contact_image_ui',

            ),
            array(

                'name' => __('First Name', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'first_name',
                'type' => 'text',

            ),

            array(

                'name' => __('Last Name', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'last_name',
                'type' => 'text',

            ),

            array(

                'name' => __('Position', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'contact_position',
                'type' => 'text',
            ),

            array(

                'name' => __('Company Name', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_name',
                'type' => 'text',

            ),

            array(

                'name' => __('Ticker Symbols', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_tickers',
                'type' => 'text',

            ),

            array(

                'name' => __('Address', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_address',
                'type' => 'text',

            ),

            array(

                'name' => __('City', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_city',
                'type' => 'text',

            ),

            array(

                'name' => __('Country', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_country',
                'type' => 'callback',
                'callback' => 'newswire_select_countries',

            ),

            array(

                'name' => __('State or Province', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_state',
                'type' => 'text',

            ),

            array(

                'name' => __('Postal Code', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_zip',
                'type' => 'text',

            ),

            array(

                'name' => __('Telephone', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_telephone',
                'type' => 'text',

            ),

            array(
                'name' => __('Email', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_email',
                'type' => 'text',

            ),
            array(
                'name' => __('Website', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'company_website',
                'type' => 'text',

            ),

        ),

        'seo_tools' => array(
            array(
                'name' => __('Meta News Keywords', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'tags',
                'type' => 'textarea',

            ),

            array(
                'name' => __('Choose URL', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'url',
                'type' => 'seo_tools_article_url',

            ),
            //Enter date and time (GMT) for publication
/*
            array(
                'name' => __('Edit date/time from defaut wordpress publish box', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'publish_date',
                'type' => 'callback',
                'callback' => 'newswire_publish_date_element',

            ), */

            array(
                'name' => __('Publication Language', 'newswire'),
                'desc' => __($newswire_config['tooltip']['seo_tools_pub_language'], 'newswire'),
                'id' => 'language',
                'type' => 'callback',
                'callback' => 'newswire_select_language',

            ),
            array(
                'name' => __('#Hashtags', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'hashtags',
                'type' => 'textarea',

            ),

        ),

        'add_image' => array(

            array("name" => __('Image Caption', 'newswire'),
                "desc" => '',
                "id" => "img_caption",
                'width' => '100%',
                "type" => "text",
            ),

            array(
                'name' => __('Image Alt Tag', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'img_alt_tag',
                'width' => '100%',
                'type' => 'text',

            ),

            array(
                'name' => __('Hyperlink Image', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'img_caption_link',
                'width' => '100%',
                'type' => 'text',

            ),

            array(
                'name' => __('Caption Link?', 'newswire'),
                'desc' => __($newswire_config['tooltip']['img_alt_tag_link'], 'newswire'),
                'id' => 'img_alt_tag_link',
                'width' => '100%',
                'type' => 'text',

            ),

            array(
                'name' => __('Include Image in Article Body', 'newswire'),
                'desc' => __($newswire_config['tooltip']['include_image'], 'newswire'),
                'id' => 'include_image',                
                'type' => 'checkbox',
                'default' => '1'
            ),
            array(
                'name' => __('Set as featured image', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => '_set_as_featured',                
                'type' => 'checkbox',
                'default' => '0'
            )



        ),

        /**
         * Iframe builder tab
         */
        'iframe_builder' => array(
            array(
                'name' => __('Video', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'embed',
                'type' => 'textarea',
                'placeholder' => __('Paste embed code from YouTube or Vimeo here. Select 300p width. Or use iFrame builder button above to use the URL of your video file. Any other embed code may also be pasted here. If you do not modify the contents of this box, a default video will appear next to your article.', 'newswire'),
            ),
            array(
                'name' => __('Google Maps', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'mapsembed',
                'placeholder' => __('Paste embed code to your location from Google Maps here. Select 300p width. See tool tip above for further instructions. Any other embed code may also be pasted here. If you do not modify the contents of this box, default content will appear next to your article.', 'newswire'),
                'type' => 'textarea',
            ),
            array(
                'name' => __('Social Media Embeds', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'fbembed',
                'placeholder' => __('Paste embed code from Facebook, Google Badges, Twitter Timeline, etc. in this box.  Check developer tools from these or other social media sources to learn how to create these codes, and size to 300 px in width.', 'newswire'),
                'type' => 'textarea',
            ),
            array(
                'name' => __('Adsense', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'adsembed',
                'placeholder' => __('If you have an approved Google AdSense account, you may paste the script here. See tool tip above for further instructions. If you do not modify the contents of this box, default content will appear next to your article.', 'newswire'),
                'type' => 'textarea',
            ),
            array(
                'name' => __('Website', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'webembed',
                'placeholder' => __('Paste iframe code for your website into this box. You may use the Website iFrame Builder linked directly above to create standard code for embedding your website here. Note: Non responsive websites may display poorly, with scroll bars in this window on your article page.', 'newswire'),
                'type' => 'textarea',
            ),

            array(
                'name' => __('Styles', 'newswire'),
                'desc' => __('', 'newswire'),
                'id' => 'styles',
                'type' => 'select',
                'std' => 'iframe_left',
                'options' => array('iframe_left' => 'iFrame Left', 'iframe_right' => 'iFrame Right', 'no_image' => 'No Image'),
            ),
        ),
    );
    return isset($tabs[$panel]) ? $tabs[$panel] : '';
};

endif;