<?php

/**
* Contains all custom permission and user roles
*/
if ( !function_exists('newswire_custom_role_caps')):

function maybe_autocreate_roles() {
    $role = 'PRReporter';
    if (get_role($role) === null) {
        //create new role
        add_role($role, 'PR Reporter', array(
            'read' => true,
            'edit_posts' => false,
            'delete_posts' => false,
            'publish_posts' => false,
            'upload_files' => true,
        ));
    }
}

/**
 * Creawte custom Roles and capabilities
 */
add_action('admin_init', 'newswire_custom_role_caps', 999);
function newswire_custom_role_caps() {
    // set_plugin_widgets_default();
    // maybe_create_singlepr_template();
    
    /*
    * Create custom user role
    */
    maybe_autocreate_roles();

    // Add the roles you'd like to administer the custom post types
    $roles = array('editor', 'administrator');
    
    // Loop through each role and assign capabilities
    foreach ($roles as $the_role) {

        $role = get_role($the_role);
        if (!$role) {
            continue;
        }

    
        //pressroom blocks caps
        $role->add_cap('edit_pressroom_block');
        $role->add_cap('read_pressroom_block');
        $role->add_cap('delete_pressroom_block');

        $role->add_cap('edit_pressroom_blocks');
        $role->add_cap('edit_others_pressroom_blocks');
        $role->add_cap('publish_pressroom_blocks');
        $role->add_cap('read_private_pressroom_blocks');
        $role->add_cap('delete_pressroom_blocks');
        $role->add_cap('delete_private_pressroom_blocks');
        $role->add_cap('delete_published_pressroom_blocks');
        $role->add_cap('delete_others_pressroom_blocks');
        $role->add_cap('edit_private_pressroom_blocks');
        $role->add_cap('edit_published_pressroom_blocks');
        $role->add_cap('ordering_blocks');
        $role->add_cap('publish_pressroom_blocks_to_pressroom');

    }
    // @Todo: will remove all roles after finalyzing them
    // 
    //from pressroom-by-newswire    
    // Add the roles you'd like to administer the custom post types
    $roles = array('editor', 'administrator');
    // Loop through each role and assign capabilities
    foreach ($roles as $the_role) {

        $role = get_role($the_role);
        if (!$role) {
            continue;
        }

        //press releases caps
        $role->add_cap('read');
        $role->add_cap('edit_newswire_pr');
        $role->add_cap('read_newswire_pr');
        $role->add_cap('delete_newswire_pr');

        $role->add_cap('edit_newswire_prs');
        $role->add_cap('edit_others_newswire_prs');
        $role->add_cap('publish_newswire_prs');
        $role->add_cap('read_private_newswire_prs');
        $role->add_cap('delete_newswire_prs');
        $role->add_cap('delete_private_newswire_prs');
        $role->add_cap('delete_published_newswire_prs');
        $role->add_cap('delete_others_newswire_prs');
        $role->add_cap('edit_private_newswire_prs');
        $role->add_cap('edit_published_newswire_prs');

        //create_posts

        //pressroom blocks caps
        $role->add_cap('edit_pressroom_block');
        $role->add_cap('read_pressroom_block');
        $role->add_cap('delete_pressroom_block');

        $role->add_cap('edit_pressroom_blocks');
        $role->add_cap('edit_others_pressroom_blocks');
        $role->add_cap('publish_pressroom_blocks');
        $role->add_cap('read_private_pressroom_blocks');
        $role->add_cap('delete_pressroom_blocks');
        $role->add_cap('delete_private_pressroom_blocks');
        $role->add_cap('delete_published_pressroom_blocks');
        $role->add_cap('delete_others_pressroom_blocks');
        $role->add_cap('edit_private_pressroom_blocks');
        $role->add_cap('edit_published_pressroom_blocks');
        $role->add_cap('ordering_blocks');
        $role->add_cap('publish_newswire_prs_to_pressroom');

    }


    //author
    $roles = array('author');
    // Loop through each role and assign capabilities
    foreach ($roles as $the_role) {

        $role = get_role($the_role);

        if (!$role) {
            continue;
        }

        //press releases caps
        $role->add_cap('read');
        $role->add_cap('edit_pressroom_block');
        $role->add_cap('read_pressroom_block');
        $role->add_cap('delete_pressroom_block');

        $role->remove_cap('edit_pressroom_blocks');
        $role->add_cap('edit_others_pressroom_blocks');
        $role->add_cap('publish_pressroom_blocks');
        $role->add_cap('read_private_pressroom_blocks');
        $role->add_cap('delete_pressroom_blocks');
        $role->add_cap('delete_private_pressroom_blocks');
        $role->add_cap('delete_published_pressroom_blocks');
        $role->add_cap('delete_others_pressroom_blocks');
        $role->add_cap('edit_private_pressroom_blocks');
        $role->add_cap('edit_published_pressroom_blocks');

        //create_posts

        //pressroom blocks caps
        $role->add_cap('edit_pressroom_block');
        $role->add_cap('read_pressroom_block');
        $role->add_cap('delete_pressroom_block');

        $role->add_cap('edit_pressroom_blocks');
        //$role->remove_cap('edit_others_pressroom_blocks');
        $role->add_cap('publish_pressroom_blocks');
        $role->remove_cap('read_private_pressroom_blocks');
        $role->add_cap('delete_pressroom_blocks');
        $role->remove_cap('delete_private_pressroom_blocks');
        $role->add_cap('delete_published_pressroom_blocks');
        $role->remove_cap('delete_others_pressroom_blocks');
        $role->remove_cap('edit_private_pressroom_blocks');
        $role->add_cap('edit_published_pressroom_blocks');
        $role->add_cap('ordering_blocks');
    }

    /**
    * Custom User type - PRReporter
    */
    $roles = array('PRReporter');

    // Loop through each role and assign capabilities
    foreach ($roles as $the_role) {

        $role = get_role($the_role);

        // if user type doesn't exist skip
        if ( !$role ) {

            continue;
        }

        /*
        * Specific to prreporter - exclusive to PRReporter
        */
        $role->add_cap('prreporter_cap_only');


        /*
        * Press releases caps
        */
        $role->remove_cap('edit_posts');
        $role->remove_cap('edit_terms');
        
        $role->add_cap('read');
        $role->add_cap('edit_pressroom_block');
        $role->add_cap('read_pressroom_block');
        $role->add_cap('delete_pressroom_block');

        $role->add_cap('edit_pressroom_blocks');
        $role->remove_cap('edit_others_pressroom_blocks');
        $role->add_cap('publish_pressroom_blocks');
        $role->remove_cap('read_private_pressroom_blocks');
        $role->add_cap('delete_pressroom_blocks');
        $role->remove_cap('delete_private_pressroom_blocks');
        $role->add_cap('delete_published_pressroom_blocks');
        $role->remove_cap('delete_others_pressroom_blocks');
        $role->remove_cap('edit_private_pressroom_blocks');
        $role->add_cap('edit_published_pressroom_blocks');

        //create_posts

        //pressroom blocks caps
        /*$role->remove_cap('edit_pressroom_block');
        $role->remove_cap('read_pressroom_block');
        $role->remove_cap('delete_pressroom_block');

        $role->remove_cap('edit_pressroom_blocks');
        $role->remove_cap('edit_others_pressroom_blocks');
        $role->remove_cap('publish_pressroom_blocks');
        $role->remove_cap('read_private_pressroom_blocks');
        $role->remove_cap('delete_pressroom_blocks');
        $role->remove_cap('delete_private_pressroom_blocks');
        $role->remove_cap('delete_published_pressroom_blocks');
        $role->remove_cap('delete_others_pressroom_blocks');
        $role->remove_cap('edit_private_pressroom_blocks');
        $role->remove_cap('edit_published_pressroom_blocks');
        $role->remove_cap('ordering_blocks');*/

    }

    /*
    * test
    $user = wp_get_current_user();
    //var_dump($user->roles);
    $user->remove_cap('update_core', false);
    $user->add_cap('edit_pressroom_block');
    $user->add_cap('prreporter_cap_only');
    //$user->add_cap('edit_posts', true);
    foreach($user->roles as $role) {
    wp_update_user( array ('ID' => $user->ID, 'role' => $role ) ) ;
    //echo $role;
    }
     */ 

    /*
    * Map capabilities 
    */
    add_filter('map_meta_cap', 'newswire_check_user_cap', 9999, 4);
    function newswire_check_user_cap($caps, $cap, $user_id, $args) {
        //var_dump($caps);
        //exit;
        return $caps;
    }

    /*
    * disallow pr menu from PRREporter and author
    */
    //if ( current_user_can('PRReporeter'))
        //remove_meta_box('tagsdiv-post_tag', 'pr', 'side');

}

endif;