<?php
/**
 * Plugin Name: NewswireXpress
 * Plugin URI:  http://www.pressroom.ninja
 * Description: Make a full-featured press room from your own WordPress site and publish press releases to the world. To get started: 1) Click the “Activate“ link to the left of this description, 2) <a href="http://newswire.net/plugin_api" target="_blank">Sign up for an API key</a>, and 3) Go to your <a href="edit.php?post_type=pr&page=newsroom-settings">Newsroom API settings page</a>, and enter your API keys.
 * Author:      DE Brown
 * Author URI:  http://newswire.net/profile/500
 * Version:    1.3
 * Text Domain: newswire
 * Domain Path: /languages/
 * License:
 *
 *
 *
 */
if ( !defined('ABSPATH') ) {
    exit;
}

if ( version_compare( PHP_VERSION, '5.3', '<' ) ) {
    add_action( 'admin_notices', 
        create_function( '', 
            "echo '<div class=\"error\"><p>" 
            .  newswire_plugin_title() . __(' requires PHP 5.3 to function properly. Please upgrade PHP or deactivate this plugin.', 'newswire') 
            . "</p></div>';" ) 
        );
    return;
}
if (defined('WP_DEBUG') && WP_DEBUG) {
    //REMOVE warning for now
    //error_reporting(E_ALL ^ (E_NOTICE | E_WARNING));
} else {
    //error_reporting(0);
}

# SET PATHS AND URLS
define('NEWSWIRE', plugin_basename(__FILE__));
define('NEWSWIRE_PLUGIN_VERSION', '0.0.43');
define('NEWSWIRE_DEVELOPMENT_MODE', true);
define('NEWSWIRE_PLUGIN_URL', plugin_dir_url(__FILE__));
define('NEWSWIRE_DIR', plugin_dir_path(__FILE__));
define('NEWSWIRE_PLUGIN_ASSETS_URL', NEWSWIRE_PLUGIN_URL . '/assets');
define('NEWSWIRE_PLUGIN_ASSETS_DIR', NEWSWIRE_DIR . '/assets');

# INCLUDES
include NEWSWIRE_DIR . '/config/config.php';
include NEWSWIRE_DIR . '/config/tooltip.php';
include NEWSWIRE_DIR . '/bootstrap.php';


register_activation_hook(__FILE__, 'newswire_pressroom_activate');
register_deactivation_hook(__FILE__, 'newswire_pressroom_deactivate');
do_action('newswire_pressroom_init');


/*
 * Add paid newswire publishing option
 */
//add_action('add_meta_boxes', 'itmooti_pr_form');
function itmooti_pr_form() {
    global $post;
    if (get_post_meta($post->ID, "newswire_article_id", true)) {
        add_meta_box(
            'itmooti_pr_form',
            'Package/Option',
            'itmooti_pr_form_callback',
            'pr',
            'side',
            'low'
        );
    }
}


/** lightbox version */
function itmooti_pr_form_callback_lightbox() {
    //newswire_payment_handler_lightbox_options();
    //return;
    /*
    featured - featured
    financial syndication - syndicated
    news video - video
    $149 single press release - spr149
    $49 single press release - spr49
    */
    global $post;

     //update_post_meta($post_ID, 'newswire_submission_result', $body);
    $newswire_submission_result = get_post_meta($post->ID, 'newswire_submission_result',true);
    
    $checkout_url = NEWSWIRE_CHECKOUT_URL;

    if ( !empty($newswire_submission_result['publishing_rights']) || current_user_can('PRReporter') ) {
        
        $option_array = array(
             array(
                '<a class="newswire-external" href="#" onclick="newswire_openblank()">Press Release $149 </a>',
                'spr149',
                'newswire-package',
                'selected'
            ),

            array(
                '<a class="newswire-external" href="#" onclick="newswire_openblank()">Feature my article $79.00</a>',
                'featured',
                'newswire-package product-hidden'
            ),
            array(
               '<a class="newswire-external" href="#" onclick="newswire_openblank()">Do a news video $139.00</a>',
                'video',
                'newswire-package product-hidden'
            ),
            array(
                '<a class="newswire-external" href="#" onclick="newswire_openblank()">Syndicate me $247.00</a>',
                'syndicated',
                'product-hidden'
            )
        );

        
    } elseif ( intval(get_post_meta($post->ID, NEWSWIRE_ARTICLE_ID, true ) ) && empty($newswire_submission_result['publishing_rights']) ) {
        
        $option_array = array(
            array(
                '<a class="newswire-external" href="#" onclick="newswire_openblank()">Feature my article $79.00</a>',
                'featured',
            ),
            array(
                '<a class="newswire-external" href="#" onclick="newswire_openblank()">Do a news video $139.00</a>',
                'video',
            ),
            array(
                '<a class="newswire-external" href="#" onclick="newswire_openblank()">Syndicate me $247.00</a>',
                'syndicated',
            ),
           /* array(
                'Press Release $149',
                'http://my.newswire.net/order-4/',
            ), */
            
        );


    }


    $email = get_userdata($post->post_author);
    $current_user = wp_get_current_user();
    if ($email) {
        $email = $email->user_email;
    } else {
        $email = $current_user->user_email;
    }
    //echo '<a href="#TB_inline?width=200&height=200&inlineId=modal-window-newswire-package-option" class="thickbox" style="display: " id="call-newswire-options">&nbsp;Test</a>';
    
    echo '<div id="modal-window-newswire-package-option" style="display:none; padding: 20px; margin:20px"><div>';
    echo '<table width="100%"><tr><td width="30%" valign="top">';
    //echo "<p> Some good text/description here about current action </p>";
    echo '<br>';
        $i = 0;
    foreach ($option_array as $k => $v) {
        $i++;
        //get values
        $checkout_products[] = $v[1];
        if ( $v[1] =='spr149') {
            //echo '<input type="hidden" name="itmooti_pr_package" value="spr149"> ';
            echo '<input type="checkbox" id="itmooti_pr_package_' . $i . '" name="itmooti_pr_package" value="' . $v[1] . '" checked="checked" disabled readonly />';

        } else {
            echo '<input type="checkbox" id="itmooti_pr_package_' . $i . '" name="itmooti_pr_package" value="' . $v[1] . '"/>';
    
        }
        

        echo '<label for="itmooti_pr_package_' . $i . '">';
        echo $v[0];
        echo '</label><br /><br />';
    }
    
    /*echo '<input type="radio" name="itmooti_pr_package" id="itmooti_pr_package_nothanks" value="close"/>';
    echo '<label for="itmooti_pr_package_nothanks" >';
    echo 'No thanks';
    echo '</label><br /><br />';
    */
    $newswire_article_id = get_post_meta($post->ID, "newswire_article_id", true);
        echo '<input type="hidden" name="itmooti_pr_article_id" id="itmooti_pr_article_id" value="' . $newswire_article_id 
        . '" /><input type="hidden" name="itmooti_pr_user_id" id="itmooti_pr_user_id" value="' 
        . get_current_user_id() . '" /><input type="hidden" name="itmooti_pr_user_email" id="itmooti_pr_user_email" value="' 
        . urlencode($email) . '" />';
    echo '<div>';
    
    echo ' <input type="button" class="button button-primary button-large" id="itmooti_pr_submit" name="itmooti_pr_submit" value="Submit" onclick="payment_page_redirect()" />';
    echo ' <input type="button" value="No Thanks"  class="button" onclick="tb_remove();">';
    echo '</div>';
    echo '</td><td>';
    ?><h4>Feature my article</h4>
    With the featured article option, your Press Release will be placed as suggested reading on the Newswire homepage, 
    above the fold, as well as throughout the site. So whether the Newswire visitor lands on the homepage, or more commonly someone else's story 
    (perhaps because they followed a link on another website, or found it on Google), it's much harder for them to leave without seeing your story. 
    <h4>News Video</h4>
    With the video feature option selected below, one of our newscasters will talk about your press release in the news video that gets published on our homepage. Newswire brings real news to our readers in a daily video newscast to bring you more readers and hundreds of thousands of visitors come to newswire every week to read the press releases and watch the news. Your video will serve to create third-party validation, which means instant credibility for you. You have full rights to use this video in your own marketing materials, such as your website, YouTube etc. Show your prospects that you are an authority worthy of being in the news.
    <h4>Syndicate Me</h4>
    If you're looking to get instant exposure with potential investors, or to gain credibility by putting  "As Seen on  Wall Street Journal, Bloomberg, Yahoo Finance" on your site, simply leave this option selected. As soon as your release is approved by our team, it will automatically be submitted to these media outlets, giving you the opportunity to get instant credibility by associating yourself with the top media outlets, and notifying investors of the content important to them.

<?php
    echo '</td></tr></table>';
    echo '</div></div>';
    
    global $current_user;
    get_currentuserinfo();
    $opt = newswire_options();
    ?><script type="text/javascript">
    <!--//
    jQuery(".newswire-external").click(function(e) {
        e.preventDefault();
       // tb_show('test');
    });

    function payment_page_redirect(){
        var url = '<?php echo $checkout_url ?>';
        var itmooti_pr_package = document.getElementsByName("itmooti_pr_package");
        var itmooti_pr_package_val= new Array;
        for(var i = 0; i < itmooti_pr_package.length; i++){
            if(itmooti_pr_package[i].checked){
                itmooti_pr_package_val.push( itmooti_pr_package[i].value );
            } else if (itmooti_pr_package[i].value =='spr149')  {
                itmooti_pr_package_val.push( itmooti_pr_package[i].value );
            }
            //console.log(itmooti_pr_package[i].value);
        }
        // /console.log(itmooti_pr_package_val);



        if( !itmooti_pr_package_val.length ){
            alert("Please select package");
        }
        else{
            itmooti_pr_package_val.sort();

            tb_remove();
            
           
            $form_page = url + '?p=' +itmooti_pr_package_val.join('-') + "&id="+document.getElementById("itmooti_pr_article_id").value
            //+"&wp_user_id="+document.getElementById("itmooti_pr_user_id").value
            +"&email="+document.getElementById("itmooti_pr_user_email").value
            +"&site_id="+'<?php echo $opt["site_id"] ?>'
            +"&first_name="+'<?php echo urlencode($current_user->user_firstname) ?>'
            +"&last_name="+'<?php echo urlencode($current_user->user_lastname) ?>';
            //alert($form_page);
            if ( console )
                console.log($form_page);
            window.open($form_page, "_blank");//window.location.href=$form_page;
            //console.log($form_page);
        }

    }
   
        jQuery(window).load(function(){
            tb_show("Packages/Options","#TB_inline?inlineId=modal-window-newswire-package-option&amp;",null);          
        });
    //-->
    </script><?php
}


